/*
 : 2006 3 21 
 :   island33@hanmail.net

Exicycler3 ߿ ʿ ⺻  
ó  Ƴ   * 
 * 
 * 
 * */



using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;




namespace ImgProc
{
	/// <summary>
	/// Class1   Դϴ.
	/// </summary>
	/// 

	// 1-based index
	public class BlobFeature 
	{
		public Rectangle [] region;		// 簢  ִ.
		public int [] Area;		//    ִ.
		public Point [] CenterOfGravity;

		public int nNumber;
		

		public BlobFeature()
		{
			region = null;
		}
		//---------------------------------------------


		public BlobFeature(int nNum)
		{
			region = new Rectangle[nNum+1];
			Area = new int [nNum+1];
			CenterOfGravity = new Point [nNum+1];

			nNumber = nNum;
		}
		//---------------------------------------------


		public void SetBlobNumber(int nNum)
		{
		
			region = new Rectangle[nNum+1];
			Area = new int [nNum+1];
			CenterOfGravity = new Point [nNum+1];

			nNumber = nNum;


			return;
		}
		//---------------------------------------------





		public int SetBlobValue(int nIdx, int left, int top, int right, int bottom)
		{
			if( nIdx>nNumber || region==null ) return -1;
			
			region[nIdx] = new Rectangle(left,top,right-left+1, bottom-top+1);

			return 1;
		}
		//---------------------------------------------





		public int SetBlobValue_Left(int nIdx, int left)
		{
			if( nIdx>nNumber || region==null ) return -1;
			
			region[nIdx] = new Rectangle(left,region[nIdx].Top,region[nIdx].Right-left+1, region[nIdx].Height);

			return 1;
		}
		//---------------------------------------------





		public int SetBlobValue_Top(int nIdx, int top)
		{
			if( nIdx>nNumber || region==null ) return -1;

			region[nIdx] = new Rectangle( region[nIdx].Left, top, region[nIdx].Width, region[nIdx].Bottom-top );


			return 1;

		}
		//---------------------------------------------






		public int SetBlobValue_Right(int nIdx, int right)
		{
			if( nIdx>nNumber || region==null ) return -1;

			region[nIdx] = new Rectangle( region[nIdx].Left, region[nIdx].Top, 
				right-region[nIdx].Left+1, region[nIdx].Height);

			return 1;
		}
		//---------------------------------------------



			public int SetBlobValue_Bottom(int nIdx, int bottom)
			{
				if( nIdx>nNumber || region==null ) return -1;

				region[nIdx] = new Rectangle( region[nIdx].Left, region[nIdx].Top, region[nIdx].Width, bottom-region[nIdx].Top );

				return 1;
			}
		//---------------------------------------------



		//  ѹ Ѿ ȼ 簢   ϴ Ȯϰ
		// 簢   Ʈ Ѵ.
		public void SetFeaturebyFeature(int nIdx, int x, int y)
		{
			// Rectangle Area Updating..
			if(x<region[nIdx].Left || region[nIdx].Left==0) SetBlobValue_Left( nIdx, x);
			if(x>region[nIdx].Right) SetBlobValue_Right( nIdx, x);
		
			if(y<region[nIdx].Top || region[nIdx].Top==0) SetBlobValue_Top( nIdx, y );
			if(y>region[nIdx].Bottom) SetBlobValue_Bottom( nIdx, y );

			// Area Update.
			Area[nIdx]++;
			CenterOfGravity[nIdx].X += x;
			CenterOfGravity[nIdx].Y += y;

			return;
		}
		//---------------------------------------------





		public void CalcCenterOfGravity()
		{	
			int i;

			for(i=1;i<nNumber+1;i++)
			{
				CenterOfGravity[i].X = CenterOfGravity[i].X/Area[i];
				CenterOfGravity[i].Y = CenterOfGravity[i].Y/Area[i];
			}
			
			return;
		}
		//---------------------------------------------



	}
	//=========================================================






	public class Morphology
	{


		public Morphology()
		{
			//
			// TODO: ⿡   ߰մϴ.
			//
		}
		//---------------------------------------------------------------------


		public static int BlobFeatureExtract(int [,] src, int nNumber, BlobFeature bf)
		{
			int x,y;
			int nHeight = src.GetLength(0);
			int nWidth = src.GetLength(1);

			bf.SetBlobNumber(nNumber);

			for(y=1;y<nHeight-1;y++)
				for(x=1;x<nWidth-1;x++)
				{
					if( src[y,x]!=0 ) bf.SetFeaturebyFeature(src[y,x],x,y);
				}

			bf.CalcCenterOfGravity();


			return 1;
		}
		//---------------------------------------------------------------------



		// , , ,  1ȼ ̸ .
		public static int Labeling(int [,] src, int [,] dst, int nLabelNumber)
		{
			int x,y;
			int nHeight = src.GetLength(0);
			int nWidth = src.GetLength(1);

			Array.Clear(dst,0,dst.Length);

			int nLastLabelNumber=1;
			int [] arrUpdateCandi = new int [100000];
		//	arrUpdateCandi.SetValue(0,10000);
			
			for(y=1;y<nHeight-1;y++)
				for(x=1;x<nWidth-1;x++)
				{
					if(src[y,x]==0) continue;
					
					if(dst[y,x-1]==0)	// if B=0
					{
						if(dst[y-1,x]==0)	// if C=0
						{
							if(dst[y-1,x-1]==0) dst[y,x]=nLastLabelNumber++;
							else dst[y,x]=dst[y-1,x-1];
						}
						else dst[y,x] = dst[y-1,x]; // if C!=0							
					}
					else
					{
						if(dst[y-1,x]==0)	// if C=0
						{
							dst[y,x]=dst[y,x-1];							
						}
						else 
						{
							if( dst[y,x-1]==dst[y-1,x] ) // BC  .							
								dst[y,x] = dst[y,x-1];							
							else // BC  ٸ
							{	// AB  ְ, BC ε Ѵ.
								dst[y,x] = dst[y,x-1];

							//	UpdateCandi cd = new UpdateCandi();
								if(dst[y,x-1]<=dst[y-1,x]) arrUpdateCandi[dst[y-1,x]] = dst[y,x-1];
								else arrUpdateCandi[dst[y,x-1]] = dst[y-1,x];								
							}
						}
					}
				}


			int [] nSorted = new int[nLastLabelNumber];
			int [] nTemp = new int[nLastLabelNumber];
			
			int i;
			int nCnt=0;
			for(i=1;i<nLastLabelNumber;i++)
			{
				if( arrUpdateCandi[i] == 0 ) nCnt++;			
			}

			int Idx;
			for(i=nLastLabelNumber-1;i>0;i--)
			{
				Idx = arrUpdateCandi[i];
				while(arrUpdateCandi[Idx]!=0) Idx = arrUpdateCandi[Idx];
				arrUpdateCandi[i] = Idx;
			}


			for(i=1;i<nLastLabelNumber;i++)	nTemp[i] = 0;
			for(i=1;i<nLastLabelNumber;i++) nTemp[arrUpdateCandi[i]]++;
			
			nLabelNumber = nTemp[0];


			int Increase=1;
			for(i=1;i<nLastLabelNumber;i++)
				if(nTemp[i]!=0) nTemp[i] = Increase++;

			for(i=1;i<nLastLabelNumber;i++)
			{
				if(arrUpdateCandi[i]!=0)
					arrUpdateCandi[i] = nTemp[arrUpdateCandi[i]];
			}


			for(y=1;y<nHeight-1;y++)
			for(x=1;x<nWidth-1;x++)
			{
				dst[y,x] = arrUpdateCandi[dst[y,x]];
			}	

			nSorted = null;
			nTemp = null;
			arrUpdateCandi = null;

			return nLabelNumber;
		}
		//---------------------------------------------------------------------



	

		// 3 X 3 smoothing..
		public static int Smoothing_Three(int [,] src, int [,]dst)
		{
			int x,y;
			int [,] nMask = new int[3,3] {{1,1,1},{1,2,1},{1,1,1}};


			int nHeight = src.GetLength(0);
			int nWidth = src.GetLength(1);
			
			int nWeight=0;


			for(y=0;y<3;y++)
			for(x=0;x<3;x++)
			{
				nWeight += nMask[y,x];
			}

			for(y=1;y<nHeight-1;y++)
			for(x=1;x<nWidth-1;x++)
			{
				dst[y,x] = nMask[0,0]*src[y-1,x-1] + nMask[0,1]*src[y-1,x] + nMask[0,2]*src[y-1,x+1] +
						nMask[1,0]*src[y,x-1] + nMask[1,1]*src[y,x] + nMask[1,2]*src[y,x+1] +
						nMask[2,0]*src[y+1,x-1] + nMask[2,1]*src[y+1,x] + nMask[2,2]*src[y+1,x+1];

				dst[y,x] = dst[y,x]/nWeight;
			}

			return 1;

		}
		//---------------------------------------------------------------------





/*
		public int Convolution(int [,] src, int [,]dst, int [,] mask)
		{
			int nHeight = src.GetLength(0);
			int nWidth = src.GetLength(1);

			int nMaskHeight = dst.GetLength(0);
			int nMaskWidth = dst.GetLength(1);

			if( nMaskHeight>nHeight || nMaskWidth>nWidth) return -1;


			int x,y;	// ̹ ε
			int mx, my;	// ũ ε

			int nMaskCenterX = nMaskWidth/2;
			int nMaskCenterY = nMaskHeight/2;

			int nMaskCntX=(nMaskWidth+1)/2;
			int nMaskCntY=(nMaskHeight+1)/2;


			for(y=0;y<nMaskHeight/2;y++)
			for(x=0;x<nMaskWidth/2;x++)
			{

				for(my=0;my>nMaksCntY;my++)
				for(mx=0;my>nMaskCntX;mx++)
				{
					mask[nMaskCenterY+my,nMaskCenterX+mx]*src[y+my,x+mx];
				}


				for(my=0;my<y;my++)
				for(mx=0;mx<x;mx++)
				{
					mask[nMaskCenterY+my,nMaskCenterX+mx]
				}



			}

			return 1;
		}
		//---------------------------------------------------------------------
*/


	}




}





















